'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var language = require('@codemirror/language');
var haskell = require('@codemirror/legacy-modes/mode/haskell');

function indentation() {
    return language.indentService.of((context, pos) => {
        if (context.lineIndent(pos, -1)) {
            return;
        }
        let { text, from } = context.lineAt(pos, -1);
        let parse = text.slice(0, pos - from).match(/^([^$#]+)\$.*/);
        if (parse) {
            return Math.min(parse[1].length, 8);
        }
        else {
            return null;
        }
    });
}

function tidal() {
    return [indentation(), language.StreamLanguage.define(haskell.haskell)];
}

exports.tidal = tidal;
