import { indentService, StreamLanguage } from '@codemirror/language';
import { haskell } from '@codemirror/legacy-modes/mode/haskell';

function indentation() {
    return indentService.of((context, pos) => {
        if (context.lineIndent(pos, -1)) {
            return;
        }
        let { text, from } = context.lineAt(pos, -1);
        let parse = text.slice(0, pos - from).match(/^([^$#]+)\$.*/);
        if (parse) {
            return Math.min(parse[1].length, 8);
        }
        else {
            return null;
        }
    });
}

function tidal() {
    return [indentation(), StreamLanguage.define(haskell)];
}

export { tidal };
